/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCorePerson.TCorePersonPath;
import de.ship.db.tables.TDmMaillist.TDmMaillistPath;
import de.ship.db.tables.records.TDmPersonRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TDmPerson extends TableImpl<TDmPersonRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_dm_person</code>
     */
    public static final TDmPerson T_DM_PERSON = new TDmPerson();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TDmPersonRecord> getRecordType() {
        return TDmPersonRecord.class;
    }

    /**
     * The column <code>common_dd.t_dm_person.lastchange</code>.
     */
    public final TableField<TDmPersonRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_dm_person.pk</code>.
     */
    public final TableField<TDmPersonRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_dm_person.fk_usnr</code>. person id
     */
    public final TableField<TDmPersonRecord, Integer> FK_USNR = createField(DSL.name("fk_usnr"), SQLDataType.INTEGER.nullable(false), this, "person id");

    /**
     * The column <code>common_dd.t_dm_person.user_mail</code>. mail address of
     * recipient
     */
    public final TableField<TDmPersonRecord, String> USER_MAIL = createField(DSL.name("user_mail"), SQLDataType.CLOB.nullable(false), this, "mail address of recipient");

    private TDmPerson(Name alias, Table<TDmPersonRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TDmPerson(Name alias, Table<TDmPersonRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_dm_person</code> table reference
     */
    public TDmPerson(String alias) {
        this(DSL.name(alias), T_DM_PERSON);
    }

    /**
     * Create an aliased <code>common_dd.t_dm_person</code> table reference
     */
    public TDmPerson(Name alias) {
        this(alias, T_DM_PERSON);
    }

    /**
     * Create a <code>common_dd.t_dm_person</code> table reference
     */
    public TDmPerson() {
        this(DSL.name("t_dm_person"), null);
    }

    public <O extends Record> TDmPerson(Table<O> path, ForeignKey<O, TDmPersonRecord> childPath, InverseForeignKey<O, TDmPersonRecord> parentPath) {
        super(path, childPath, parentPath, T_DM_PERSON);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TDmPersonPath extends TDmPerson implements Path<TDmPersonRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TDmPersonPath(Table<O> path, ForeignKey<O, TDmPersonRecord> childPath, InverseForeignKey<O, TDmPersonRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TDmPersonPath(Name alias, Table<TDmPersonRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TDmPersonPath as(String alias) {
            return new TDmPersonPath(DSL.name(alias), this);
        }

        @Override
        public TDmPersonPath as(Name alias) {
            return new TDmPersonPath(alias, this);
        }

        @Override
        public TDmPersonPath as(Table<?> alias) {
            return new TDmPersonPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TDmPersonRecord, Integer> getIdentity() {
        return (Identity<TDmPersonRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TDmPersonRecord> getPrimaryKey() {
        return Keys.PK_DM_PERSON;
    }

    @Override
    public List<ForeignKey<TDmPersonRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_DM_PERSON__FK_USNR_PERSON);
    }

    private transient TCorePersonPath _tCorePerson;

    /**
     * Get the implicit join path to the <code>common_dd.t_core_person</code>
     * table.
     */
    public TCorePersonPath tCorePerson() {
        if (_tCorePerson == null)
            _tCorePerson = new TCorePersonPath(this, Keys.T_DM_PERSON__FK_USNR_PERSON, null);

        return _tCorePerson;
    }

    private transient TDmMaillistPath _tDmMaillist;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_dm_maillist</code> table
     */
    public TDmMaillistPath tDmMaillist() {
        if (_tDmMaillist == null)
            _tDmMaillist = new TDmMaillistPath(this, null, Keys.T_DM_MAILLIST__FK_DM_PERSON.getInverseKey());

        return _tDmMaillist;
    }

    @Override
    public TDmPerson as(String alias) {
        return new TDmPerson(DSL.name(alias), this);
    }

    @Override
    public TDmPerson as(Name alias) {
        return new TDmPerson(alias, this);
    }

    @Override
    public TDmPerson as(Table<?> alias) {
        return new TDmPerson(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmPerson rename(String name) {
        return new TDmPerson(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmPerson rename(Name name) {
        return new TDmPerson(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmPerson rename(Table<?> name) {
        return new TDmPerson(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmPerson where(Condition condition) {
        return new TDmPerson(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmPerson where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmPerson where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmPerson where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmPerson where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmPerson where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmPerson where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmPerson where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmPerson whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmPerson whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
